<?php
##### gedcom_import_purge_dbsetup.php, created by ###Gedcom Import Purge, by Robin Richmond
# Creates or deletes a flag field in the Medialinks table that marks medialinks
# created by the Gedcom import process rather than the TNG editor(s).
# Installed by the Gedcom Import-Purge mod.
# Must be run after the mod is installed but before the next Gedcom Import.
# If the field exists, the program will note that, and invoke itself with a querystring
# parameter whose value in English is "Delete It".
# If the field does not exist, the program will note that, and invoke itself with a
# querystring parameter whose value in English is "Create It".
#
# v5f - 24 Jul 2021
#  Fixed an undefined variable error that occurred when checking for the form actions (variable $b1)
# v5d - 29 Oct 2020
#  Added error checking, and moved the file into the .cfg file
# v12 - Jun 2016
# In order to avoid a weird PHP/TNG conflict that causes Admin programs
# running outside of the standard TNG folder to reset the user session,
# this program was
# - modified to run in the standard TNG folder, and
# - renamed so that its origins are clear.
$tngModNames['Gedcom Import-Purge']['gedcom_import_purge_dbsetup.php'] = '5f'; #Register this mod

include("begin.php");
include($cms['tngpath'] ."adminlib.php");
$textpart = "textplus";
include($cms['tngpath'] ."getlang.php");
include($cms['tngpath'] ."$mylanguage/admintext.php");
$admin_login = 1;
include($cms['tngpath'] ."checklogin.php");
include($cms['tngpath'] ."version.php");
require($cms['tngpath'] ."adminlog.php");
########################################################
#Read custom language strings from a mods subfolder rather than from standard TNG custom text files.
$modfolder = 'gedcom_import_purge_v14.0.0.5g';
include("$modspath/$modfolder/languages/English_custtext.php");
if ($mylanguage != "languages/English" && file_exists("$modspath/$modfolder/{$mylanguage}_custtext.php"))
	include("$modspath/$modfolder/{$mylanguage}_custtext.php");
########################################################

if (isset($tngconfig['tabs'])) $flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['rrgip-heading1'], $flags );
echo "</head>\n";

echo tng_adminlayout();

$purgetabs[0] = array(1,"rrgedcomimportpurge_dbsetup.php", $admtext['rrgip-tab0'],"setup");
$innermenu = "<a href=\"#\" onclick='window.close();' class=\"lightlink\">{$admtext['rrgip-returntomm']}</a>";
$menu = doMenu($purgetabs,"setup",$innermenu);

echo displayHeadline($admtext['rrgip-heading1'] , "{$cms['tngpath']}img/photos_icon.gif",$menu,$message);
?>

<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">
    <span class="subhead"><strong><?php echo $admtext['rrgip-heading2']; ?></strong></span><br/><br/>
<?php
	$fieldname = "createdfromgedcom";
	//Before displaying the form, take any action that was specified by button b1
	if (empty($b1)) $b1='';
	if ($b1 == $admtext['rrgip-create']) {
		//Double-check that it does not exist
		$query = "SHOW columns FROM $medialinks_table WHERE field = \"$fieldname\"";
		$result = tng_query($query);
		if (tng_num_rows($result) == 0) {
			//Create the field
			$query = "ALTER TABLE $medialinks_table ADD $fieldname TINYINT NOT NULL DEFAULT '0' COMMENT 'Created by the Gedcom Import Purge mod'";
			echo "<div>SQL Command: $query </div>\n";
			$result = @tng_query($query);
			if( $result )
				echo "...{$admtext['rrgip-done']}\n";
			else
				echo "...<strong>{$admtext['rrgip-notcreated']}</strong>\n";
		} else {
			echo "<p><strong>{$admtext['rrgip-alreadyexists']}</strong></p>\n";
		}
	} elseif ($b1 == $admtext['rrgip-delete']) {
		//Double-check that it still exists
		$query = "SHOW columns FROM $medialinks_table WHERE field = \"$fieldname\"";
		$result = tng_query($query);
		if (tng_num_rows($result) == 1) {
			//Delete the field.
			$query = "ALTER TABLE $medialinks_table DROP $fieldname";
			echo "<div>SQL Command: $query </div>\n";
			$result = @tng_query($query);
			if( $result ) echo "...{$admtext['rrgip-done']}\n";
			else echo "...<strong>{$admtext['rrgip-notdeleted']}</strong>\n";
		} else {
			echo "<p><strong>{$admtext['rrgip-alreadygone']}</strong></p>\n";
		}
	}
	############# End of actions  ############

	#Check for the field and display the appropriate action button
	$query = "SHOW columns FROM $medialinks_table WHERE field = \"$fieldname\"";
	$result = tng_query($query);
	$fieldIsPresent = (tng_num_rows($result) == 1);
	tng_free_result($result);

	echo "<form>\n";
		echo "<p style='font-size:115%; font-weight:bold;'>";
		if ($fieldIsPresent) {
			echo "{$admtext['rrgip-exists']}&emsp;
				<input type=\"submit\" name=\"b1\" value=\"{$admtext['rrgip-delete']}\" />";
		}
		else {
			echo "{$admtext['rrgip-notexist']}&emsp;
				<input type=\"submit\" name=\"b1\" value=\"{$admtext['rrgip-create']}\" />";
		}
	echo "</p></form>
	<p style='font-weight:bold;'>{$admtext['rrgip-close']}</p>
";
?>
</td>
</tr>
</table>
<?php
echo tng_adminfooter();
?>
